/*
 * Copyright (C) 2014 Laboratoire ThéMA - UMR 6049 - CNRS / Université de Franche-Comté
 * http://thema.univ-fcomte.fr
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */


package org.thema.graphab.metric;

import java.awt.BorderLayout;
import java.util.ArrayList;
import java.util.Collection;
import java.util.List;
import javax.swing.DefaultComboBoxModel;
import org.thema.graphab.Project;
import org.thema.graphab.Project.Method;
import org.thema.graphab.graph.AbstractGraph;
import org.thema.graphab.habitat.MultiHabitat;

/**
 * Dialog for selecting a graph, a metric and his parameters
 * @author Gilles Vuidel
 */
public class CalcMetricDialog<T extends Metric> extends javax.swing.JDialog {

    /** the selected graph */
    public AbstractGraph graph;
    /** the selected metric */
    public T metric;
    /** the name of the metric result */
    public String name;
    
    public String filter;
    /** has user clicked Ok ? */
    public boolean isOk = false;

    private Method method;

    private Project project;
    
    /**
     * Creates new form CalcMetricDialog 
     * @param parent parent frame
     * @param project
     * @param graphs collection of graphs
     * @param method
     */
    public CalcMetricDialog(java.awt.Frame parent, Project project, Collection<AbstractGraph> graphs, Method method) {
        super(parent, true);
        initComponents();
        setLocationRelativeTo(parent);
        getRootPane().setDefaultButton(okButton);
        
        this.project = project;
        this.method = method;
        graphComboBox.setModel(new DefaultComboBoxModel(graphs.toArray()));

        graphComboBoxActionPerformed(null);
    }


    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        okButton = new javax.swing.JButton();
        cancelButton = new javax.swing.JButton();
        graphComboBox = new javax.swing.JComboBox();
        jLabel1 = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();
        paramPanel = new javax.swing.JPanel();
        metricComboBox = new org.thema.graphab.metric.MetricComboBox();
        jLabel3 = new javax.swing.JLabel();
        nameTextField = new javax.swing.JTextField();
        selectButton = new javax.swing.JButton();
        mhCheckBox = new javax.swing.JCheckBox();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        java.util.ResourceBundle bundle = java.util.ResourceBundle.getBundle("org/thema/graphab/Bundle"); // NOI18N
        setTitle(bundle.getString("CalcMetricDialog.title")); // NOI18N

        java.util.ResourceBundle bundle1 = java.util.ResourceBundle.getBundle("org/thema/graphab/metric/Bundle"); // NOI18N
        okButton.setText(bundle1.getString("CalcMetricDialog.okButton.text")); // NOI18N
        okButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                okButtonActionPerformed(evt);
            }
        });

        cancelButton.setText(bundle1.getString("CalcMetricDialog.cancelButton.text")); // NOI18N
        cancelButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cancelButtonActionPerformed(evt);
            }
        });

        graphComboBox.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                graphComboBoxActionPerformed(evt);
            }
        });

        jLabel1.setText(bundle1.getString("CalcMetricDialog.jLabel1.text")); // NOI18N

        jLabel2.setText(bundle1.getString("CalcMetricDialog.jLabel2.text")); // NOI18N

        paramPanel.setBorder(javax.swing.BorderFactory.createTitledBorder(bundle1.getString("CalcMetricDialog.paramPanel.border.title"))); // NOI18N
        paramPanel.setLayout(new java.awt.BorderLayout());

        metricComboBox.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                metricComboBoxActionPerformed(evt);
            }
        });

        jLabel3.setText(bundle1.getString("CalcMetricDialog.jLabel3.text")); // NOI18N

        nameTextField.setText(bundle1.getString("CalcMetricDialog.nameTextField.text")); // NOI18N

        selectButton.setText(bundle1.getString("CalcMetricDialog.selectButton.text")); // NOI18N
        selectButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                selectButtonActionPerformed(evt);
            }
        });

        mhCheckBox.setText(bundle1.getString("CalcMetricDialog.mhCheckBox.text")); // NOI18N
        mhCheckBox.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                mhCheckBoxActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(paramPanel, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                        .addGap(0, 0, Short.MAX_VALUE)
                        .addComponent(okButton, javax.swing.GroupLayout.PREFERRED_SIZE, 67, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(cancelButton))
                    .addGroup(layout.createSequentialGroup()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jLabel1)
                            .addComponent(jLabel2))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(graphComboBox, 0, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                    .addComponent(metricComboBox, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(jLabel3)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(nameTextField))
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(mhCheckBox)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(selectButton)
                        .addGap(0, 0, Short.MAX_VALUE)))
                .addContainerGap())
        );

        layout.linkSize(javax.swing.SwingConstants.HORIZONTAL, new java.awt.Component[] {cancelButton, okButton});

        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(graphComboBox, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel1))
                .addGap(18, 18, 18)
                .addComponent(jLabel2)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(metricComboBox, javax.swing.GroupLayout.PREFERRED_SIZE, 25, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(paramPanel, javax.swing.GroupLayout.PREFERRED_SIZE, 221, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(mhCheckBox)
                    .addComponent(selectButton))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel3)
                    .addComponent(nameTextField))
                .addGap(18, 18, 18)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(cancelButton)
                    .addComponent(okButton))
                .addContainerGap())
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void okButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_okButtonActionPerformed

        graph = (AbstractGraph) graphComboBox.getSelectedItem();
        metric = (T)metricComboBox.getSelectedItem();
        metric.setParams(((ParamPanel)paramPanel.getComponent(0)).getParams());
        name = nameTextField.getText().isBlank() ? null : nameTextField.getText();
        isOk = true;
        setVisible(false);
        dispose();
    }//GEN-LAST:event_okButtonActionPerformed

    private void cancelButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cancelButtonActionPerformed
        setVisible(false);
        dispose();
    }//GEN-LAST:event_cancelButtonActionPerformed

    private void graphComboBoxActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_graphComboBoxActionPerformed
        graph = (AbstractGraph) graphComboBox.getSelectedItem();
        List<Metric> inds = new ArrayList<>();
        for(Metric ind : Project.getMetricsFor(method)) {
            if (ind.isAcceptGraph(graph)) {
                inds.add(ind);
            }
        }
        metricComboBox.setMetrics(inds);
    }//GEN-LAST:event_graphComboBoxActionPerformed

    private void metricComboBoxActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_metricComboBoxActionPerformed
        paramPanel.removeAll();
        T metric = (T) metricComboBox.getSelectedItem();
        paramPanel.add(metric.getParamPanel(((AbstractGraph) graphComboBox.getSelectedItem()).getLinkset()), BorderLayout.CENTER);
        paramPanel.revalidate();
        paramPanel.repaint();
        boolean mh = metric instanceof MHMetric && ((AbstractGraph) graphComboBox.getSelectedItem()).getHabitat() instanceof MultiHabitat;
        mhCheckBox.setEnabled(mh);
        selectButton.setEnabled(mh && mhCheckBox.isSelected() || method == Method.LOCAL || method == Method.DELTA);
    }//GEN-LAST:event_metricComboBoxActionPerformed

    private void selectButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_selectButtonActionPerformed
        SelectMetricDialog dlg = new SelectMetricDialog(this, (Metric)metricComboBox.getSelectedItem(), 
                (AbstractGraph)graphComboBox.getSelectedItem(), method, mhCheckBox.isSelected(), filter);
        dlg.setVisible(true);
        
        if(!dlg.isOk) {
            return;
        }

        ((MHMetric)metricComboBox.getSelectedItem()).setSelection(dlg.select);
        this.filter = dlg.filter;
        
    }//GEN-LAST:event_selectButtonActionPerformed

    private void mhCheckBoxActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_mhCheckBoxActionPerformed
        selectButton.setEnabled(mhCheckBox.isSelected() || method == Method.LOCAL || method == Method.DELTA);
        ((MHMetric)metricComboBox.getSelectedItem()).setSelection(mhCheckBox.isSelected() ? MHMetric.ALL : null);
    }//GEN-LAST:event_mhCheckBoxActionPerformed

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton cancelButton;
    private javax.swing.JComboBox graphComboBox;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private org.thema.graphab.metric.MetricComboBox metricComboBox;
    private javax.swing.JCheckBox mhCheckBox;
    private javax.swing.JTextField nameTextField;
    private javax.swing.JButton okButton;
    private javax.swing.JPanel paramPanel;
    private javax.swing.JButton selectButton;
    // End of variables declaration//GEN-END:variables

}
